#f[^̓ǂݍ݂Ɛ}
Data <- read.csv("alfonsino.csv", header=T)
Age <- Data$Age
Length <- Data$Length
Sex <- as.numeric(Data$Sex)
mark <- c(19,5)
plot(Length~Age,pch=mark[Sex],xlim=c(0,25),ylim=c(0,50))
legend(18,20,pch=mark,legend=c("Female","Male"),bty="n")

# von Bertalanffy Ȑ
growth.VB <- function(t,Linf,K,t0) Linf*(1.0-exp(-K*(t-t0)))
# Richards Ȑ
growth.RC <- function(t,Linf,K,t0,log_delta) (Linf*(1.0-exp(-K*(t-t0))))^exp(log_delta)

#@p[^̐
start <- list(Linf=rep(max(Length),2),K=c(0.1,0.1),t0=c(0,0))
res.111 <- nls(Length~growth.VB(t=Age,Linf[Sex], K[Sex], t0[Sex]), start=start)
summary(res.111)
confint(res.111)

taxis <- seq(0,25,0.5); tlen <- length(taxis);
pred.female.111 <- predict(res.111, list(Age=taxis, Sex=rep(1,tlen)))
pred.male.111 <- predict(res.111, list(Age=taxis, Sex=rep(2,tlen)) )
plot(Length~Age,pch=mark[Sex],xlim=c(0,25),ylim=c(0,50))
points(taxis, pred.female.111, type="l", lty=1)
points(taxis, pred.male.111, type="l", lty=2)
legend(18,15,pch=mark,lty=c(1,2),legend=c("Female","Male"),bty="n")

start <- list(Linf=max(Length),K=0.1,t0=0)
res.000 <- nls(Length~growth.VB(t=Age,Linf, K, t0), start=start)
summary(res.000)
confint(res.000)

win.graph()
pred.000 <- predict(res.000, list(Age=taxis))
plot(Length~Age,xlim=c(0,25),ylim=c(0,50))
points(taxis, pred.000, type="l")

AIC(res.111)
AIC(res.000)


start <- list(Linf=max(Length),K=0.1,t0=-10)
RC.000 <- nls(Length~growth.RC(t=Age,Linf, K, t0, log_delta=0), start=start)
summary(RC.000)
confint(RC.000)